/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIWebBrowserPrint.idl
 */

#ifndef __gen_nsIWebBrowserPrint_h__
#define __gen_nsIWebBrowserPrint_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIDOMWindow; /* forward declaration */

class nsIPrintSettings; /* forward declaration */

class nsIWebProgressListener; /* forward declaration */


/* starting interface:    nsIWebBrowserPrint */
#define NS_IWEBBROWSERPRINT_IID_STR "9a7ca4b0-fbba-11d4-a869-00105a183419"

#define NS_IWEBBROWSERPRINT_IID \
  {0x9a7ca4b0, 0xfbba, 0x11d4, \
    { 0xa8, 0x69, 0x00, 0x10, 0x5a, 0x18, 0x34, 0x19 }}

/**
 * The nsIWebBrowserPrint
 */
class NS_NO_VTABLE nsIWebBrowserPrint : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IWEBBROWSERPRINT_IID)

  /**
   * Returns a PrintSettings object 
   * Creates a new the first time, if one doesn't exist.
   * then returns the same object each time after that
   * unless a different object was set into it.
   */
  /* attribute nsIPrintSettings printSettings; */
  NS_IMETHOD GetPrintSettings(nsIPrintSettings * *aPrintSettings) = 0;
  NS_IMETHOD SetPrintSettings(nsIPrintSettings * aPrintSettings) = 0;

  /**
   * This returns the current settings that was last used for printing
   * or page setup. For peinring, the print engine always sets the PrintSettings
   * from whoever is printing into the global settings
   * for page setup it is the responsibilitity of those implementing page setup
   * to set their setting into the global settings
   */
  /* attribute nsIPrintSettings globalPrintSettings; */
  NS_IMETHOD GetGlobalPrintSettings(nsIPrintSettings * *aGlobalPrintSettings) = 0;
  NS_IMETHOD SetGlobalPrintSettings(nsIPrintSettings * aGlobalPrintSettings) = 0;

  /**
   * Print the specified DOM window
   *
   * aDOMWindow - The DOM window to print
   * aThePrintOptions - Printer Settings for the print job
   */
  /* void print (in nsIDOMWindow aDOMWindow, in nsIPrintSettings aThePrintSettings, in nsIWebProgressListener aWPListener); */
  NS_IMETHOD Print(nsIDOMWindow *aDOMWindow, nsIPrintSettings *aThePrintSettings, nsIWebProgressListener *aWPListener) = 0;

  /**
   * Print Preview the specified DOM window
   *
   * aDOMWindow - The DOM window to print preview
   * aThePrintOptions - Printer Settings for the print preview
   */
  /* void printPreview (in nsIDOMWindow aDOMWindow, in nsIPrintSettings aThePrintSettings); */
  NS_IMETHOD PrintPreview(nsIDOMWindow *aDOMWindow, nsIPrintSettings *aThePrintSettings) = 0;

  /* void cancel (); */
  NS_IMETHOD Cancel(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIWEBBROWSERPRINT \
  NS_IMETHOD GetPrintSettings(nsIPrintSettings * *aPrintSettings); \
  NS_IMETHOD SetPrintSettings(nsIPrintSettings * aPrintSettings); \
  NS_IMETHOD GetGlobalPrintSettings(nsIPrintSettings * *aGlobalPrintSettings); \
  NS_IMETHOD SetGlobalPrintSettings(nsIPrintSettings * aGlobalPrintSettings); \
  NS_IMETHOD Print(nsIDOMWindow *aDOMWindow, nsIPrintSettings *aThePrintSettings, nsIWebProgressListener *aWPListener); \
  NS_IMETHOD PrintPreview(nsIDOMWindow *aDOMWindow, nsIPrintSettings *aThePrintSettings); \
  NS_IMETHOD Cancel(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIWEBBROWSERPRINT(_to) \
  NS_IMETHOD GetPrintSettings(nsIPrintSettings * *aPrintSettings) { return _to GetPrintSettings(aPrintSettings); } \
  NS_IMETHOD SetPrintSettings(nsIPrintSettings * aPrintSettings) { return _to SetPrintSettings(aPrintSettings); } \
  NS_IMETHOD GetGlobalPrintSettings(nsIPrintSettings * *aGlobalPrintSettings) { return _to GetGlobalPrintSettings(aGlobalPrintSettings); } \
  NS_IMETHOD SetGlobalPrintSettings(nsIPrintSettings * aGlobalPrintSettings) { return _to SetGlobalPrintSettings(aGlobalPrintSettings); } \
  NS_IMETHOD Print(nsIDOMWindow *aDOMWindow, nsIPrintSettings *aThePrintSettings, nsIWebProgressListener *aWPListener) { return _to Print(aDOMWindow, aThePrintSettings, aWPListener); } \
  NS_IMETHOD PrintPreview(nsIDOMWindow *aDOMWindow, nsIPrintSettings *aThePrintSettings) { return _to PrintPreview(aDOMWindow, aThePrintSettings); } \
  NS_IMETHOD Cancel(void) { return _to Cancel(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIWEBBROWSERPRINT(_to) \
  NS_IMETHOD GetPrintSettings(nsIPrintSettings * *aPrintSettings) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPrintSettings(aPrintSettings); } \
  NS_IMETHOD SetPrintSettings(nsIPrintSettings * aPrintSettings) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetPrintSettings(aPrintSettings); } \
  NS_IMETHOD GetGlobalPrintSettings(nsIPrintSettings * *aGlobalPrintSettings) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetGlobalPrintSettings(aGlobalPrintSettings); } \
  NS_IMETHOD SetGlobalPrintSettings(nsIPrintSettings * aGlobalPrintSettings) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetGlobalPrintSettings(aGlobalPrintSettings); } \
  NS_IMETHOD Print(nsIDOMWindow *aDOMWindow, nsIPrintSettings *aThePrintSettings, nsIWebProgressListener *aWPListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->Print(aDOMWindow, aThePrintSettings, aWPListener); } \
  NS_IMETHOD PrintPreview(nsIDOMWindow *aDOMWindow, nsIPrintSettings *aThePrintSettings) { return !_to ? NS_ERROR_NULL_POINTER : _to->PrintPreview(aDOMWindow, aThePrintSettings); } \
  NS_IMETHOD Cancel(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Cancel(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsWebBrowserPrint : public nsIWebBrowserPrint
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIWEBBROWSERPRINT

  nsWebBrowserPrint();
  virtual ~nsWebBrowserPrint();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsWebBrowserPrint, nsIWebBrowserPrint)

nsWebBrowserPrint::nsWebBrowserPrint()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsWebBrowserPrint::~nsWebBrowserPrint()
{
  /* destructor code */
}

/* attribute nsIPrintSettings printSettings; */
NS_IMETHODIMP nsWebBrowserPrint::GetPrintSettings(nsIPrintSettings * *aPrintSettings)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsWebBrowserPrint::SetPrintSettings(nsIPrintSettings * aPrintSettings)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIPrintSettings globalPrintSettings; */
NS_IMETHODIMP nsWebBrowserPrint::GetGlobalPrintSettings(nsIPrintSettings * *aGlobalPrintSettings)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsWebBrowserPrint::SetGlobalPrintSettings(nsIPrintSettings * aGlobalPrintSettings)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void print (in nsIDOMWindow aDOMWindow, in nsIPrintSettings aThePrintSettings, in nsIWebProgressListener aWPListener); */
NS_IMETHODIMP nsWebBrowserPrint::Print(nsIDOMWindow *aDOMWindow, nsIPrintSettings *aThePrintSettings, nsIWebProgressListener *aWPListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void printPreview (in nsIDOMWindow aDOMWindow, in nsIPrintSettings aThePrintSettings); */
NS_IMETHODIMP nsWebBrowserPrint::PrintPreview(nsIDOMWindow *aDOMWindow, nsIPrintSettings *aThePrintSettings)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void cancel (); */
NS_IMETHODIMP nsWebBrowserPrint::Cancel()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIWebBrowserPrint_h__ */
